package cn.yw.nhyw.nhywjtxhdgl.action;

import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.util.*;
import cn.yw.nhyw.nhywjtxhdgl.service.NhywjtxhdglService;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@SuppressWarnings({"all"})
@Component("nhywjtxhdglAction")
public class NhywjtxhdglAction extends BaseAction {
    private static final long serialVersionUID = 1L;
    private static Logger iLog = Logger.getLogger(NhywjtxhdglAction.class);

    @Autowired
    private NhywjtxhdglService service;

    /**
     * 分页
     */
    @OperateType(value = LogConstants.LOG_QUERY, info = "listNhywjtxhdglByPage")
    public void listNhywjtxhdglByPage() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            int page = Integer.parseInt(Struts2Utils.getParameter("page"));
            int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
            int start = ((page == 0 ? 1 : page) - 1) * rows;
            map.put("start", start);
            map.put("limit", rows);
            Struts2Utils.renderJson(this.service.listNhywjtxhdglByPage(map));
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjtxhdglAction-listNhywjtxhdglByPage-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 查询总数
     */
	/*
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Nhywjtxhdgl")
	public void count_Nhywjtxhdgl(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Nhywjtxhdgl(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtxhdglAction-count_Nhywjtxhdgl-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/

    /**
     * 查询 Nhywjtxhdgl
     */
    @OperateType(value = LogConstants.LOG_GET, info = "query_Nhywjtxhdgl")
    public void query_Nhywjtxhdgl() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            Struts2Utils.renderJson(this.service.query_AllNhywjtxhdgl(map));
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjtxhdglAction-query_Nhywjtxhdgl-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 查询 一条Nhywjtxhdgl
     */
    @OperateType(value = LogConstants.LOG_GET, info = "get_Nhywjtxhdgl")
    public void get_Nhywjtxhdgl() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            Struts2Utils.renderJson(this.service.get_Nhywjtxhdgl(map));
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjtxhdglActionquery_Nhywjtxhdgl-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 删除
     */
    @OperateType(value = LogConstants.LOG_DELETE, info = "deleteNhywjtxhdgl")
    public void delete_Nhywjtxhdgl() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            if (!CommUtils.isEmpty(map)) {
                int result = service.delete_Nhywjtxhdgl(map);
                Struts2Utils.renderJson(Constants.SUCCESS);
            } else {
                throw new Exception("请正确的选择删除记录!!!");
            }
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjtxhdglAction-delete_Nhywjtxhdgl-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 插入
     */
    @OperateType(value = LogConstants.LOG_ADD, info = "insert_Nhywjtxhdgl")
    public void insert_Nhywjtxhdgl() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            if (StringUtil.checkEmpty(map.get("xh"))) {
                map.put("xh", StringUtil.getUUID());
            }
            if (!StringUtil.checkEmpty(map.get("checkparam"))) {
                Map sMap = new HashMap();
                sMap.put("tableparam", map.get("checkparam"));
                List ls = service.query_Nhywjtxhdgl(sMap);
                if (!StringUtil.checkEmpty(ls) || ls.size() > 0) {
                    Struts2Utils.renderJson(Constants.SAME);
                } else {
                    service.insert_Nhywjtxhdgl(map);
                    Struts2Utils.renderJson(Constants.SUCCESS);
                }
            } else {
                service.insert_Nhywjtxhdgl(map);
                Struts2Utils.renderJson(Constants.SUCCESS);
            }
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjtxhdglAction-insert_Nhywjtxhdgl()-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 修改
     */
    @OperateType(value = LogConstants.LOG_UPDATE, info = "update_Nhywjtxhdgl")
    public void update_Nhywjtxhdgl() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            if (!StringUtil.checkEmpty(map.get("checkparam"))) {
                Map sMap = new HashMap();
                sMap.put("tableparam", map.get("checkparam"));
                List ls = service.query_Nhywjtxhdgl(sMap);
                if (!StringUtil.checkEmpty(ls) || ls.size() > 0) {
                    Struts2Utils.renderJson(Constants.SAME);
                } else {
                    int result = service.update_Nhywjtxhdgl(map);
                    Struts2Utils.renderJson(Constants.SUCCESS);
                }
            } else {
                int result = service.update_Nhywjtxhdgl(map);
                Struts2Utils.renderJson(Constants.SUCCESS);
            }
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjtxhdglAction-update_Nhywjtxhdgl-error: " + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 修改经纬度
     */
    @OperateType(value = LogConstants.LOG_UPDATE, info = "updateJtxhdJdWdByXh")
    public void updateJtxhdJdWdByXh() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            if (!StringUtil.checkEmpty(map.get("checkparam"))) {
                Map sMap = new HashMap();
                sMap.put("tableparam", map.get("checkparam"));
                List ls = service.query_Nhywjtxhdgl(sMap);
                if (!StringUtil.checkEmpty(ls) || ls.size() > 0) {
                    Struts2Utils.renderJson(Constants.SAME);
                } else {
                    int result = service.updateJtxhdJdWdByXh(map);
                    Struts2Utils.renderJson(Constants.SUCCESS);
                }
            } else {
                int result = service.updateJtxhdJdWdByXh(map);
                Struts2Utils.renderJson(Constants.SUCCESS);
            }
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjthlglAction-updateJthlJdWdByXh-error: " + e);
            Struts2Utils.renderJson(null);
        }
    }

    /**
     * 批量删除
     */
	/*
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Nhywjtxhdgl")
	public void batch_delete_Nhywjtxhdgl(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Nhywjtxhdgl(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtxhdglAction-batch_delete_Nhywjtxhdgl-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/

    /**
     * 导出Excel
     */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Nhywjtxhdgl")
	public void exp_Nhywjtxhdgl(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Nhywjtxhdgl(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "交通信号灯管理-"+dateTime);
			params.put("sheetName", "交通信号灯管理");
			params.put("header", "交通信号灯管理");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtxhdglAction-exoprtExcel-error:" +e);
			
		}
	}
	*/

    /**
     * 导入Excel
     */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Nhywjtxhdgl")
	public String imp_Nhywjtxhdgl(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("NhywjtxhdglAction-imp_Nhywjtxhdgl-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
    //查询信号灯状态,mysql 表的异常信息与oracle 表中的路灯表进行右关联，得出状态信息
    @OperateType(value = LogConstants.LOG_UPDATE, info = "listNhywjtxhdglStatusByPage")
    public void listNhywjtxhdglStatusByPage() {
        try {
            Map map = Struts2Utils.getRequestParameterMap();
            //信号灯的所有异常信息
            Map xhdstatusmap = service.listNhywjtxhdglStatusByPage(map);
            List<Map> xhdstatemap = (List<Map>) xhdstatusmap.get("rows");
            int page = Integer.parseInt(Struts2Utils.getParameter("page"));
            int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
            int start = ((page == 0 ? 1 : page) - 1) * rows;
            map.put("start", start);
            map.put("limit", rows);
            //信号灯的分页信息
            Map xhdmap = service.listNhywjtxhdglByPage(map);
            List<Map> xhdmaplist = (List<Map>) xhdmap.get("rows");
            boolean ischeck = false;
            //遍历两个集合获得结果
            for (Map mapLD : xhdmaplist) {
                for (Map mapLDState : xhdstatemap) {
                    if (null!=mapLD.get("qybh") && null!=mapLDState.get("noarea")
                            &&null!=mapLD.get("lkh") && null!=mapLDState.get("nojunc")
                    &&mapLD.get("qybh").equals(String.valueOf(mapLDState.get("noarea")))
                            && mapLD.get("lkh").equals(String.valueOf(mapLDState.get("nojunc")))) {
                        mapLD.putAll(mapLDState);
                        ischeck = true;
                    }
                }
                if (!ischeck) {
                    mapLD.put("mode", null);
                    mapLD.put("time", null);
                }
            }
            xhdmap.put("rows", xhdmaplist);
            Struts2Utils.renderJson(xhdmap);
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjthlglAction-listNhywjtxhdglStatusByPage-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

    //查询信号灯历史状态,关联运维表 获得区域名称，路口名称，路灯名称
    @OperateType(value = LogConstants.LOG_UPDATE, info = "listNhywjtxhdglHistoryStateByPage")
    public void listNhywjtxhdglHistoryStateByPage() {
        Map map = Struts2Utils.getRequestParameterMap();
        try {
            int page = Integer.parseInt(Struts2Utils.getParameter("page"));
            int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
            int start = ((page == 0 ? 1 : page) - 1) * rows;
            map.put("start", start);
            map.put("limit", rows);
            map.put("qybh", Struts2Utils.getParameter("qybh"));
            map.put("lkh", Struts2Utils.getParameter("lkh"));
            //信号灯的历史异常信息
            Map xhdhistory = this.service.listNhywjtxhdglHistoryStateByPage(map);
            List<Map> xhdmaplist =(List<Map>)xhdhistory.get("rows");

            Map xhd= this.service.listNhywjtxhdglByPage(map);
            for (Map mapLD : (List<Map>) xhd.get("rows")) {
                for (Map mapLDState :xhdmaplist) {
                    if (null!=mapLD.get("qybh") && null!=mapLDState.get("noarea")
                            &&null!=mapLD.get("lkh") && null!=mapLDState.get("nojunc")
                            &&mapLD.get("qybh").equals(String.valueOf(mapLDState.get("noarea")))
                            && mapLD.get("lkh").equals(String.valueOf(mapLDState.get("nojunc")))) {
                        mapLDState.putAll(mapLD);
                    }
                }
            }
            xhdhistory.put("rows", xhdmaplist);
            Struts2Utils.renderJson(xhdhistory);
        } catch (Exception e) {
            e.printStackTrace();
            iLog.error("NhywjthlglAction-listNhywjtxhdglHistoryStateByPage-error:" + e);
            Struts2Utils.renderJson(null);
        }
    }

}
